#this is a thermostat class 
# @author Anil Neupane
require 'thermostat.rb'

class JSONThermostat


  #the data gets decoded from JSON format and  initialised here: the temperature, range and the unit
  attr_accessor :settings
  def initialize(settingjson)
    @settings = JSON.parse(settingjson)
    @wanted_value = unit_conversion(settings['temperature'], settings['unit'])
    @range = unit_conversion(settings['range'], settings['unit']).abs
  end


  #the above initialised data gets converted by calling the methode unit_conversion if needed.
  attr_accessor :temp, :wanted_value, :range
  def update(update_value)
    @temp = JSON.parse(update_value)
    updated_temp = unit_conversion(temp['temperature'], temp['unit'])
    Thermostat.checkTemp(updated_temp, wanted_value, range)
  end


#this method checks for the unit of the given value and converts to celsius if needed
#@param value [integer] the value
#@param unit [String] the unit of the given value
#@return [integer] the converted value or the original if there's no need of conversion
  attr_accessor :value, :unit
  def unit_conversion(value, unit)
    @value = value
    @unit  = unit
    if unit == 'fahrenheit'
      return (value - 32) / 1.8

  elsif unit == 'kelvin'
    return value - 273.15
  else
    return value
    end
  end
end
